package com.japontelucena.services;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public class JoseSaxHandler extends DefaultHandler {

	private static final String CURRENT_CONDITIONS =
			//      "current_conditions";
			"current_condition";
	private static final String DATA = "data";
	private static final String CONDITION = "weatherDesc"; //"condition";
	private static final String TEMP_F = "temp_F"; //"temp_f";
	private static final String WIND_SPEED_KM = "windspeedKmph";
	private static final String WIND_DEGREE = "winddirDegree";
	private static final String WIND_DIRECTION = "winddir16Point";
	private static final String PRECIPITATION = "precipMM";
	private static final String HUMIDITY = "humidity";
	private static final String PRESSURE = "pressure";
	private static final String CLOUD_COVER = "cloudcover";


	private Weather weather = new Weather();

	private boolean boolean_current_conditions = false;

	// Added:
	private boolean boolean_temp_f = false;
	private boolean boolean_weather_Description = false;
	private boolean boolean_wind_speed_km = false;
	private boolean boolean_wind_degree = false;
	private boolean boolean_wind_direction = false;
	private boolean boolean_precipitation = false;
	private boolean boolean_humidity = false;
	private boolean boolean_pressure = false;
	private boolean boolean_cloud_cover = false;
	// End of some Added code.

	public Weather getWeather() {
		return weather;
	}

	@Override
	public void startElement(String str_Namespace_URI,
			String str_Local_Name, String str_Query_Name,
			Attributes attributes_Weather) throws SAXException {

		if (str_Local_Name.equals(CURRENT_CONDITIONS)) {
			boolean_current_conditions = true;
		} else {
			if (boolean_current_conditions) {
				if (str_Local_Name.equals(TEMP_F)) 
					boolean_temp_f = true;
				else if (str_Local_Name.equals(CONDITION))
					boolean_weather_Description = true;
				else if (str_Local_Name.equals(WIND_SPEED_KM))
					boolean_wind_speed_km = true;
				else if (str_Local_Name.equals(WIND_DEGREE))
					boolean_wind_degree = true;
				else if (str_Local_Name.equals(WIND_DIRECTION))
					boolean_wind_direction = true;
				else if (str_Local_Name.equals(PRECIPITATION))
					boolean_precipitation = true;
				else if (str_Local_Name.equals(HUMIDITY))
					boolean_humidity = true;
				else if (str_Local_Name.equals(PRESSURE))
					boolean_pressure = true;
				else if (str_Local_Name.equals(CLOUD_COVER))
					boolean_cloud_cover = true;
				
			}
		}
	}

	@Override
	public void characters(char chars_Weather[], int int_Start, int int_Length) throws SAXException {
		if (boolean_temp_f) 
			weather.setTemperature(Integer.parseInt(String.valueOf(chars_Weather, int_Start, int_Length)));
		else if (boolean_weather_Description) 
			weather.setCondition(String.valueOf(chars_Weather, int_Start, int_Length));
		else if (boolean_wind_speed_km)
			weather.set_Wind_Speed_Km(Integer.parseInt(String.valueOf(chars_Weather, int_Start, int_Length)));
		else if (boolean_wind_degree)
			weather.set_Wind_Degree(Integer.parseInt(String.valueOf(chars_Weather, int_Start, int_Length)));
		else if (boolean_wind_direction)
			weather.set_Wind_Direction(String.valueOf(chars_Weather, int_Start, int_Length));
		else if (boolean_precipitation)
			weather.set_Precipitation_MM(Double.parseDouble(String.valueOf(chars_Weather, int_Start, int_Length)));
		else if (boolean_humidity)
			weather.set_Humidity_Perc(Integer.parseInt(String.valueOf(chars_Weather, int_Start, int_Length)));
		else if (boolean_pressure)
			weather.set_Pressure(Integer.parseInt(String.valueOf(chars_Weather, int_Start, int_Length)));
		else if (boolean_cloud_cover)
			weather.set_Cloud_Cover_Perc(Integer.parseInt(String.valueOf(chars_Weather, int_Start, int_Length)));
	}

	@Override
	public void endElement(String str_Namespace_URI,
			String str_Local_Name, String str_Query_Name) throws SAXException {
		if (str_Local_Name.equals(CURRENT_CONDITIONS)) 
			boolean_current_conditions = false;
		else { 
			if (str_Local_Name.equals(TEMP_F)) 
				boolean_temp_f = false;
			else if (str_Local_Name.equals(CONDITION)) 
				boolean_weather_Description = false;
			else if (str_Local_Name.equals(WIND_SPEED_KM))
				boolean_wind_speed_km = false;
			else if (str_Local_Name.equals(WIND_DEGREE)) 
				boolean_wind_degree = false;
			else if (str_Local_Name.equals(WIND_DIRECTION))
				boolean_wind_direction = false;
			else if (str_Local_Name.equals(PRECIPITATION)) 
				boolean_precipitation = false;
			else if (str_Local_Name.equals(HUMIDITY))
				boolean_humidity = false;
			else if (str_Local_Name.equals(PRESSURE)) 
				boolean_pressure = false;
			else if (str_Local_Name.equals(CLOUD_COVER))
				boolean_cloud_cover = false;
		}
	}
}
