package com.japontelucena.services;

import java.net.URL;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

import android.app.Service;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.os.Messenger;
import android.os.RemoteException;
import android.widget.Toast;

public class JoseWeatherService extends Service {

	Messenger messenger_Weather = null;

	private static final String DEFAULT_WEATHER_INFO = "Dark @ Night";

	@Override
	public IBinder onBind(Intent intent_Weather) {
		show_Toast(R.string.service_bound);
		return new Weather_Fetcher();
	}

	class Weather_Fetcher extends WeatherInterface.Stub {
		
		public String fetch_Weather(String str_Location) {
			
			String str_Weather = null;
			Weather weather_Info;
			
			if (str_Location != null) {
				weather_Info = get_Weather(str_Location);
				str_Weather = weather_Info.toString();
			}
			
			return str_Weather;
		}
	}	

	void show_Toast(int resource) {
		Toast.makeText(this, resource, Toast.LENGTH_SHORT).show();
	}

	String get_Weather_String(Message message) {
		Bundle bundle_Message = message.getData();
		String str_Location = bundle_Message.getString("location");
		Weather weather_Info;
		String str_Weather;
		if (str_Location != null && !str_Location.equals("")) {
			weather_Info = get_Weather(str_Location);
			str_Weather = weather_Info.toString();
		} else {
			str_Weather = DEFAULT_WEATHER_INFO;
		}
		return str_Weather;
	}

	//private static final String GOOGLE_WEATHER_URL = "http://www.google.com/ig/api?weather=";
	// ********************
	private static final String YOUR_WORLD_WEATHER_ONLINE_KEY = "59adc47a12190850120911";
	// ********************
	private static final String WORLD_WEATHER_ONLINE_URL="http://free.worldweatheronline.com/feed/weather.ashx?key=" + YOUR_WORLD_WEATHER_ONLINE_KEY + "&q=";

	public Weather get_Weather(String location) {
		URL url_Weather;
		Weather weather_Info = null;
		SAXParser parser_Weather;
		XMLReader reader_Weather;
		JoseSaxHandler saxHandler_Weather;

		try {
			//url = new URL(GOOGLE_WEATHER_URL + location.replace(" ", "%20"));
			url_Weather = new URL(WORLD_WEATHER_ONLINE_URL + location.replace(" ", "%20"));
			parser_Weather = SAXParserFactory.newInstance().newSAXParser();
			reader_Weather = parser_Weather.getXMLReader();
			saxHandler_Weather = new JoseSaxHandler();
			reader_Weather.setContentHandler(saxHandler_Weather);
			reader_Weather.parse(new InputSource(url_Weather.openStream()));

			weather_Info = saxHandler_Weather.getWeather();

		} catch (Exception e) {
			e.printStackTrace();
		}
		return weather_Info;
	}

}
